#include "include/mns.h"

int rpcscan(struct in_addr, FILE *);

const static char rpcservs[] =
   "mountd rstatd nlockmgr status nisd ttdb autofsd amd";

int rpc(struct in_addr target, FILE *fsp) {
  if(mns_opts & VERBOSE) fprintf(fsp, "\n\tRPC Services ->");
  else fprintf(fsp, "\n\tPossible RPC Vulns ->");
  if(rpcscan(target, fsp)) fprintf(fsp, " ( none )");
  return(0);
}

int rpcscan(struct in_addr target, FILE *fsp) {
   SAin svraddr;
   struct pmaplist *pm_head = NULL, *pm_walk = NULL;
   int sockett = RPC_ANYSOCK;
   struct timeval timeout;
   register CLIENT *client;
   struct rpcent *rpc;
   char rpcchkd[250] = " ";
   
   svraddr.sin_addr = target;
   svraddr.sin_family = AF_INET;
   svraddr.sin_port = htons (PMAPPORT);
   timeout.tv_sec = TIMEOUT << 1;
   timeout.tv_usec = 0;

   signal (SIGALRM, &sighandler);
   /* cause clnttcp_create uses connect() */
   alarm (TIMEOUT << 1);

   if(!(client = clnttcp_create(&svraddr, PMAPPROG, PMAPVERS, &sockett,
                                50, 500)))
   {
      alarm(0);
      perror("clnttcp_create()");
      return(-1);
   }
   alarm (0);

   if(clnt_call(client, PMAPPROC_DUMP, (xdrproc_t)xdr_void, NULL,
	        (xdrproc_t)xdr_pmaplist, &pm_head, timeout) != RPC_SUCCESS)
   {
      perror("clnt_call");
      return(-1);
   }  

   if (!pm_head) return(-1);

   for (pm_walk = pm_head; pm_walk; pm_walk = pm_walk->pml_next) {
      if((rpc = getrpcbynumber(pm_walk->pml_map.pm_prog))) {
         if(mns_opts & VERBOSE)
            fprintf(fsp, "\n\t\t%li  v.%li  %4li %s  %-10s %s",
                    pm_walk->pml_map.pm_prog,
                    pm_walk->pml_map.pm_vers,
                    pm_walk->pml_map.pm_port,
                    (pm_walk->pml_map.pm_prot == IPPROTO_TCP) ?
                    "tcp" : "udp",
                    rpc->r_name,
                    strstr(rpcservs, rpc->r_name) ? "( vuln )" : " "
            );
         else if(strstr(rpcservs, rpc->r_name) &&
                   !strstr(rpcchkd, rpc->r_name))
            if(strlen(rpcchkd) + strlen(rpc->r_name) < 300) {
               strcat(rpcchkd, rpc->r_name);
               fprintf(fsp, rpc->r_name);
               break;
            }
      }
   }
   return(0);
}
